

function adj2=prepare_optimization(opt,spokes,system,adj)
% function adj2=prepare_optimization(opt,spokes,system,adj)

adj2=adj;

% non-zero pixels
if strcmpi(opt.display,'on')
    figure; imagesc(adj.roi); axis image off; title('Optimization ROI');
end

adj2.ind=find(adj.roi>0);
adj2.nnonzeropixels=size(adj2.ind,1);
[indx indy indz]=ind2sub( [adj.nx adj.ny adj.nz],adj2.ind );
[tmpx tmpy tmpz]=ndgrid(adj.xs,adj.ys,adj.zs);
adj2.nonzeropixels=[indx indy indz tmpx(adj2.ind) tmpy(adj2.ind) tmpz(adj2.ind)];

% target magnetization
adj2.mttimg=adj2.roi * sin( opt.tfa/180.0*pi );
adj2.mtt=adj2.mttimg( adj2.ind );

% display B1 maps
nfigsx=ceil(sqrt(system.ncoils));
if nfigsx*(nfigsx-1)>system.ncoils
    nfigsy=nfigsx-1;
else
    nfigsy=nfigsx;
end
if strcmpi(opt.display,'on')
    to_disp=conv_3Dstack_2_2Dimg( permute(adj2.b1maps,[2 3 1]),nfigsx,nfigsy ) ;
    
    f=figure;
    imagesc(abs(to_disp)); axis image; axis off; colormap(hot); colorbar;
    title('Amplitude of B1 maps [T/V]');

    f=figure;
    imagesc(angle(to_disp)); axis image; axis off; colormap(hot); colorbar; caxis([-pi pi]);
    title('Phase of B1 maps [T/V]');
end

% display B0 map
if strcmpi(opt.display,'on')
    figure;
    imagesc(adj2.b0map); axis image; axis off; colormap(hot); colorbar;
    title('B0 map [Hz]');
end






