

function opt2=prepare_optimization_new(opt,spokes,data,system)
% function opt2=prepare_optimization(opt,spokes,system)
opt.display='off';
opt.nx=128;
opt.ny=128;
opt.nz=1;
opt.lx=128*0.0031;
opt.ly=128*0.0031;
opt.lz=opt.nz*spokes.sthick;
opt.b1=data.matrix.B1;%T/V
% opt.b0=data.xB0.B0;%T
opt2=opt;


% non-zero pixels
% roi=reshape( read_fdata( opt2.roipath,-1 ),opt2.nx,opt2.ny,opt2.nz );
% if strcmpi(opt.display,'on')
%     figure; imagesc(roi); axis image; title('Optimization ROI')
% end

n=1;
for k=1:opt2.nz
    for j=1:opt2.ny
        for i=1:opt2.nx
%             if roi(i,j,k)>0
                opt2.nnonzeropixels=opt2.nnonzeropixels + 1;
                opt2.nonzeropixels(n,1)=i; 
                opt2.nonzeropixels(n,2)=j;
                opt2.nonzeropixels(n,3)=k;
                opt2.nonzeropixels(n,4)=(i-0.5)/opt2.nx*opt2.lx - opt2.lx/2;
                opt2.nonzeropixels(n,5)=(j-0.5)/opt2.ny*opt2.ly - opt2.ly/2;
                opt2.nonzeropixels(n,6)=(k-0.5)/opt2.nz*opt2.lz - opt2.lz/2;
                n=n+1;
%             end
        end
    end
end

% target magnetization
opt2.mtt=[];
opt2.mttimg=zeros(opt2.nx,opt2.ny,opt2.nz);
for n=1:opt2.nnonzeropixels
    [i j k x y z]=get_coord_non_zero_pixel(opt2,n);
    if abs([x y z]*spokes.sdir - spokes.soff)<=spokes.sthick
        opt2.mtt(n,1)=sin( opt2.tfa/180.0*pi );
    else
        opt2.mtt(n,1)=0;
    end
    opt2.mttimg(i,j,k)=opt2.mtt(n,1);
end


% read B1 maps
nfigs=ceil(sqrt(opt2.nrows*opt2.ncoilspr));
rowint2char(1)='a'; rowint2char(2)='b'; rowint2char(3)='c'; rowint2char(4)='d'; rowint2char(5)='e';
opt2.b1maps=zeros(opt2.nrows*opt2.ncoilspr,opt2.nx,opt2.ny,opt2.nz);
if strcmpi(opt.display,'on')
    h1=figure; h2=figure; mask=roi>0;
end
for row=1:opt2.nrows
    for chn=1:opt2.ncoilspr        
        opt2.b1maps( chn+(row-1)*opt2.ncoilspr,:,:,: )=reshape( read_fdata( sprintf('%s_row%c_coil%d_%d_%d_%d_mag',opt2.b1mapspref,rowint2char(row),chn,opt2.nx,opt2.ny,opt2.nz),-1 ) ...
            .*exp( 1j*read_fdata( sprintf('%s_row%c_coil%d_%d_%d_%d_pha',opt2.b1mapspref,rowint2char(row),chn,opt2.nx,opt2.ny,opt2.nz),-1 ) ) ...
            ,opt2.nx,opt2.ny,opt2.nz );
        if strcmpi(opt.display,'on')
            figure(h1); subplot(nfigs,nfigs,chn+(row-1)*opt2.ncoilspr); imagesc(abs(reshape(opt2.b1maps(chn+(row-1)*opt2.ncoilspr,:,:,1),opt2.nx,opt2.ny).*mask)); axis image; axis off; colormap(hot); colorbar;
            figure(h2); subplot(nfigs,nfigs,chn+(row-1)*opt2.ncoilspr); imagesc(angle(reshape(opt2.b1maps(chn+(row-1)*opt2.ncoilspr,:,:,1),opt2.nx,opt2.ny).*mask)/pi*180.0); axis image; axis off; colormap(hot); caxis([-180 180]); colorbar;
        end
    end
end
if strcmpi(opt.display,'on')
    figure(h1); axes('Units','Normal','Position',[.075 .075 .85 .85],'Visible','off'); set(get(gca,'Title'),'Visible','on'); title('Amplitude of B1 maps (T/V)');
    figure(h2); axes('Units','Normal','Position',[.075 .075 .85 .85],'Visible','off'); set(get(gca,'Title'),'Visible','on'); title('Phase of B1 maps (deg.)');
end





