

function spokes2=prepare_pulse(spokes,opt,system)
% function spokes2=prepare_pulse(spokes,opt,system)

gamma=42.576*1e6;

spokes2=prepare_gradient_spokes(spokes,system);

N=spokes2.ntimesperspoke;
g=spokes2.g(1:N,:)*spokes2.sdir(:);
spokes2.Gss=abs(g(ceil(N/2),1));  % slice selection plateau
omega=gamma*(spokes2.Gss)*(spokes2.sthick);

times=([1:N]'-0.5-N/2)*system.deltat;
ind_rf=find(spokes2.mask_rf(1:N)>0);
Nrf=ind_rf(end)-ind_rf(1);
Trf=Nrf*system.deltat;

x=omega*times;        

f1=sinc(x);
f2=rect( times/Trf );    
f3=0.54 + 0.46*cos( 2*pi*times/Trf );  % hanning window
        
spokes2.sinc=f1.*f2.*f3;    
spokes2.sinc=spokes2.sinc/max(abs(spokes2.sinc));  % normalization of the RF amplitude
spokes2.sumsincsq=sum(abs(spokes2.sinc).^2);

if strcmpi(opt.display,'on')
    figure;
    times=[1:spokes2.ntimes]'*system.deltat;
    subplot(2,1,1); plot(times*1e3,spokes2.g(:,1)*1e3,'Color','blue','LineWidth',2); hold on;
    plot(times*1e3,spokes2.g(:,2)*1e3,'Color','red','LineWidth',2);
    plot(times*1e3,spokes2.g(:,3)*1e3,'Color','green','LineWidth',2);
    legend('Gx','Gy','Gz','Location','EastOutside'); legend('boxoff');
    title('Gradient trajectory [mT/m]','FontSize',12);

    subplot(2,1,2); plot(times*1e3,spokes2.k(:,1),'Color','blue','LineWidth',2); hold on;
    plot(times*1e3,spokes2.k(:,2),'Color','red','LineWidth',2);
    plot(times*1e3,spokes2.k(:,3),'Color','green','LineWidth',2);
    legend('kx','ky','kz','Location','EastOutside'); legend('boxoff');
    title('K-space trajectory [1/m]','FontSize',12); xlabel('Time [ms]');
end



