
function data=read_fld_file(filepath,display)
% function data=read_fld_file(filepath)
% nx=128;
% ny=128;%for show the images
%header
fileID=fopen(filepath,'r');
data.header.magic=fread(fileID,1,'int32');
if data.header.magic ~= hex2dec('70747866');
    error('Incorrect magic number');
end
data.header.gamma=fread(fileID,1,'float');  %Hz/T
data.header.npixels=fread(fileID,1,'int32');
data.header.nchannels=fread(fileID,1,'int32');
fprintf('gamma=%eHz/T\nnumber of pixels=%d\nnumber of channels=%d\n',data.header.gamma,data.header.npixels,data.header.nchannels);

%matrix
%b1p %B1+ maps
data.matrix.magic=fread(fileID,1,'int32');
if data.matrix.magic ~=hex2dec('6D617472');
    error('Incorrect magic number');
end
data.matrix.nRow=fread(fileID,1,'int32');
data.matrix.nCol=fread(fileID,1,'int32');
data.matrix.typeSize=fread(fileID,1,'int32');
data.matrix.reserved=fread(fileID,1,'int32');
fprintf('number of rows=%d\nnumber of coloums=%d\n',data.matrix.nRow,data.matrix.nCol);
tmp=fread(fileID,data.matrix.nRow*data.matrix.nCol*2,'float');


%xB0 %B0 map & voxel positions
data.matrix.magic=fread(fileID,1,'int32');
if data.matrix.magic ~=hex2dec('6D617472');
    error('Incorrect magic number');
end
data.matrix.nRow=fread(fileID,1,'int32');
data.matrix.nCol=fread(fileID,1,'int32');
data.matrix.typeSize=fread(fileID,1,'int32');
data.matrix.reserved=fread(fileID,1,'int32');
fprintf('number of rows=%d\nnumber of coloums=%d\n',data.matrix.nRow,data.matrix.nCol);
data.xB0.ori=fread(fileID,data.header.npixels*4,'float');  %T
data.xB0.ori=reshape(data.xB0.ori,4,size(data.xB0.ori,1)/4);


%W %mask
data.matrix.magic=fread(fileID,1,'int32');
if data.matrix.magic ~=hex2dec('6D617472');
    error('Incorrect magic number');
end
data.matrix.nRow=fread(fileID,1,'int32');
data.matrix.nCol=fread(fileID,1,'int32');
data.matrix.typeSize=fread(fileID,1,'int32');
data.matrix.reserved=fread(fileID,1,'int32');
fprintf('number of rows=%d\nnumber of coloums=%d\n',data.matrix.nRow,data.matrix.nCol);
data.ROI=fread(fileID,data.header.npixels,'int8');

%num of slices
data.nslices=fread(fileID,1,'int32');
fprintf('number of slices=%d\n',data.nslices);

%soda %slice orientation data

for n=1:data.nslices
    data.soda(n).p=fread(fileID,3,'float');
    data.soda(n).v1=fread(fileID,3,'float');
    data.soda(n).v2=fread(fileID,3,'float');
    data.soda(n).dx=fread(fileID,1,'float');
    data.soda(n).dy=fread(fileID,1,'float');%mm
    data.soda(n).nx=fread(fileID,1,'int32');
    data.soda(n).ny=fread(fileID,1,'int32');
    data.soda(n).ori=fread(fileID,1,'int8');
    data.soda(n).psd=fread(fileID,1,'int8');
    fprintf('slice=%d:\np=[%.2e %.2e %.2e];\nv1=[%.2e %.2e %.2e];\nv2=[%.2e %.2e %.2e];\ndx=%.2e;dy=%.2e;nx=%d;ny=%d;\nori=%d;psd=%d\n;',n,data.soda(n).p(1),data.soda(n).p(2),data.soda(n).p(3),data.soda(n).v1(1),data.soda(n).v1(2),data.soda(n).v1(3),data.soda(n).v2(1),data.soda(n).v2(2),data.soda(n).v2(3),data.soda(n).dx,data.soda(n).dy,data.soda(n).nx,data.soda(n).ny,data.soda(n).ori,data.soda(n).psd);
end

data.B1=reshape((tmp(1:2:end)+1i*tmp(2:2:end)),data.soda(1).nx,data.soda(1).ny,data.nslices,data.header.nchannels);
data.xB0.B0=reshape(data.xB0.ori(1,:),data.soda(1).nx,data.soda(1).ny,data.nslices);
data.xB0.x=reshape(data.xB0.ori(2,:),data.soda(1).nx,data.soda(1).ny,data.nslices);
data.xB0.y=reshape(data.xB0.ori(3,:),data.soda(1).nx,data.soda(1).ny,data.nslices);
data.xB0.z=reshape(data.xB0.ori(4,:),data.soda(1).nx,data.soda(1).ny,data.nslices);
data.ROI=reshape(data.ROI,data.soda(1).nx,data.soda(1).ny,data.nslices);
% 
% if strcmpi(display,'on')
%     showB1(data.B1)
% end
% 
% if strcmpi(display,'on')
%     figure,imagesc(data.xB0.B0);colorbar;axis image;title('B0 map[unit:T]','FontSize',12)
%     figure,plot(data.xB0.ori(2,1:128),'r');hold on;plot(data.xB0.ori(3,:),'g');hold on;plot(data.xB0.ori(4,:),'b');title('Postions','FontSize',12)
% end
% 
% if strcmpi(display,'on')
%     figure,imagesc(data.ROI);colorbar;axis image;title('ROI','FontSize',12)
% end