
function data=read_fld_file(filepath,display)
% function data=read_fld_file(filepath)

fileID=fopen(filepath,'r');
data.header.magic=fread(fileID,1,'int32');
if data.header.magic ~= hex2dec('70747866');
    error('Incorrect magic number');
end
data.header.gamma=fread(fileID,1,'float');  %Hz/T
data.header.npixels=fread(fileID,1,'int32');
data.header.nchannels=fread(fileID,1,'int32');
fprintf('gamma=%eHz/T\nnumber of pixels=%d\nnumber of channels=%d\n',data.header.gamma,data.header.npixels,data.header.nchannels);
data.matrix.magic=fread(fileID,1,'int32');
if data.matrix.magic ~=hex2dec('6D617472');
    error('Incorrect magic number');
end
data.matrix.nRow=fread(fileID,1,'int32');
data.matrix.nCol=fread(fileID,1,'int32');
data.matrix.typeSize=fread(fileID,1,'int32');
data.matrix.reserved=fread(fileID,1,'int32');
fprintf('number of rows=%d\nnumber of coloums=%d\n',data.matrix.nRow,data.matrix.nCol);
tmp=fread(fileID,data.matrix.nRow*data.matrix.nCol*2,'float');
data.matrix.B1=(tmp(1:2:end)+1i*tmp(2:2:end));


data.matrix.magic=fread(fileID,1,'int32');
if data.matrix.magic ~=hex2dec('6D617472');
    error('Incorrect magic number');
end
data.matrix.nRow=fread(fileID,1,'int32');
data.matrix.nCol=fread(fileID,1,'int32');
data.matrix.typeSize=fread(fileID,1,'int32');
data.matrix.reserved=fread(fileID,1,'int32');
% nb1=6+4+4+4;
% tmp=fread(fileID,nb1); 
data.xB0.ori=fread(fileID,data.header.npixels*4,'float');  %T
data.xB0.ori=reshape(data.xB0.ori,4,size(data.xB0.ori,1)/4);

data.matrix.magic=fread(fileID,1,'int32');
if data.matrix.magic ~=hex2dec('6D617472');
    error('Incorrect magic number');
end
data.matrix.nRow=fread(fileID,1,'int32');
data.matrix.nCol=fread(fileID,1,'int32');
data.matrix.typeSize=fread(fileID,1,'int32');
data.matrix.reserved=fread(fileID,1,'int32');
data.ROI=fread(fileID,data.header.npixels,'int8');

% figure,plot(data.ROI);

data.nslices=fread(fileID,1,'int32');
fprintf('number of slices=%d\n',data.nslices);
data.matrix.B1=reshape(data.matrix.B1,data.matrix.nRow*data.matrix.nCol/data.nslices*data.header.nchannels,data.nslices);
data.ROI=reshape(data.ROI,data.header.npixels/data.nslices,data.nslices);
data.xB0.B0=reshape(data.xB0.ori(1,:),data.header.npixels/data.nslices,data.nslices);
data.xB0.x=reshape(data.xB0.ori(2,:),data.header.npixels/data.nslices,data.nslices);
data.xB0.y=reshape(data.xB0.ori(3,:),data.header.npixels/data.nslices,data.nslices);
data.xB0.z=reshape(data.xB0.ori(4,:),data.header.npixels/data.nslices,data.nslices);
%number of slices
% nb3=2;tmp=fread(fileID,nb3); 
for n=1:data.nslices
    data.soda(n).p=fread(fileID,3,'float');
    data.soda(n).v1=fread(fileID,3,'float');
    data.soda(n).v2=fread(fileID,3,'float');
    data.soda(n).dx=fread(fileID,1,'float');
    data.soda(n).dy=fread(fileID,1,'float');%mm
    data.soda(n).nx=fread(fileID,1,'int32');
    data.soda(n).ny=fread(fileID,1,'int32');
    data.soda(n).ori=fread(fileID,1,'int8');
    data.soda(n).psd=fread(fileID,1,'int8');
    fprintf('slice=%d:\np=[%.2e %.2e %.2e];\nv1=[%.2e %.2e %.2e];\nv2=[%.2e %.2e %.2e];\ndx=%.2e;dy=%.2e;nx=%d;ny=%d;\nori=%d;psd=%d\n;',n,data.soda(n).p(1),data.soda(n).p(2),data.soda(n).p(3),data.soda(n).v1(1),data.soda(n).v1(2),data.soda(n).v1(3),data.soda(n).v2(1),data.soda(n).v2(2),data.soda(n).v2(3),data.soda(n).dx,data.soda(n).dy,data.soda(n).nx,data.soda(n).ny,data.soda(n).ori,data.soda(n).psd);
    if strcmpi(display,'on')
        showB1(reshape(data.matrix.B1(:,n),data.soda(n).nx,data.soda(n).ny,1,data.header.nchannels));
        figure,subplot(2,2,1);imagesc(reshape(data.ROI(:,n),data.soda(n).nx,data.soda(n).ny));colorbar;axis image;title('ROI')
	    subplot(2,2,2);imagesc(reshape(data.xB0.B0(:,n),data.soda(n).nx,data.soda(n).ny));colorbar;axis image;title('B0 map[unit:T]')
        subplot(2,1,2);plot(data.xB0.ori(2,1:128),'r');hold on;plot(data.xB0.ori(3,:),'g');hold on;plot(data.xB0.ori(4,:),'b');title('Postions')
    end
end
