

function [adj sys optimization spokes sar]=read_spokes_def_file(filepath)
% function [adj sys optimization spokes sar]=read_spokes_def_file(filepath)

file=fopen(filepath,'r');

% sys parameters
tline=fgets(file);
tline=fgets(file); sys.gmax=str2num( tline(26:size(tline,2)-2) );
sys.gmax=sys.gmax*1e-3;  % mT/m -> T/m

tline=fgets(file); sys.smax=str2num( tline(28:size(tline,2)-2) );
tline=fgets(file); sys.umax=str2num( tline(38:size(tline,2)-2) );
sys.umax=sys.umax;
tline=fgets(file); sys.ncoils=str2num( tline(20:size(tline,2)-2) );
tline=fgets(file); sys.deltat=tline_to_param(tline,19,size(tline,2)-1);
tline=fgets(file); sys.delay_rf_grad=tline_to_param(tline,36,size(tline,2)-1);

% adjustment data
tline=fgets(file); tline=fgets(file);
tline=fgets(file); fldfilepath= tline(15:size(tline,2)-2) ;
eval(sprintf('load %s',fldfilepath));

adj.nx=fld_data.soda.nx;
adj.ny=fld_data.soda.ny;
adj.nz=fld_data.nslices;

adj.b1maps=permute(fld_data.B1,[4 1 2 3]);
if size(adj.b1maps,1)~=sys.ncoils
    error('Inconsistent number of channels in FLD file.');
end

tline=fgets(file); roifilepath=tline(20:size(tline,2)-2) ;
if exist(roifilepath,'file')
    eval(sprintf('load %s',roifilepath));
    adj.roi=roi;
else
    adj.roi=fld_data.ROI;
end

adj.lx=fld_data.soda.dx*adj.nx*1e-3;  % mm -> m
adj.ly=fld_data.soda.dy*adj.ny*1e-3;  % mm -> m
adj.lz=0.005;  % place holder, we don't know the real slice thickness at this point

minx=fld_data.soda.p(1)*1e-3 + fld_data.soda.dx/2*1e-3;
maxx=adj.lx-fld_data.soda.dx*1e-3 + minx;
adj.xs=linspace(minx,maxx,adj.nx)';

miny=fld_data.soda.p(2)*1e-3 + fld_data.soda.dy/2*1e-3;
maxy=adj.lx-fld_data.soda.dy*1e-3 + miny;
adj.ys=linspace(miny,maxy,adj.ny)';

adj.zs=0;

tline=fgets(file); b0filepath=tline(13:size(tline,2)-2) ;
if exist(b0filepath,'file')
    eval(sprintf('load %s',b0filepath));
    adj.b0map=b0map; 
else
    adj.b0map=fld_data.xB0.B0;
end

tline=fgets(file); optimization.tfa=tline_to_param(tline,19,size(tline,2)-2);

% spokes parameters
tline=fgets(file); tline=fgets(file);
tline=fgets(file); spokes.nspokes=tline_to_param(tline,18,size(tline,2)-2);
spokes.sdir=zeros(3,1);
tline=fgets(file); [spokes.sdir(1) spokes.sdir(2) spokes.sdir(3)]=tline_to_3params(tline,17,size(tline,2)-2);
tline=fgets(file); spokes.sthick=tline_to_param(tline,20,size(tline,2)-2);
tline=fgets(file); spokes.soff=tline_to_param(tline,34,size(tline,2)-2);
tline=fgets(file); spokes.nsinczc=tline_to_param(tline,31,size(tline,2)-2);
spokes.spcoords=zeros(spokes.nspokes,3);
for i=1:spokes.nspokes
    tline=fgets(file); [spokes.spcoords(i,1) spokes.spcoords(i,2) spokes.spcoords(i,3)]=tline_to_3params(tline,22,size(tline,2)-2);
end

% opt. parameters
tline=fgets(file); tline=fgets(file);
tline=fgets(file); optimization.niters=tline_to_param(tline,30,size(tline,2)-2);

% SAR control
tline=fgets(file); tline=fgets(file);
tline=fgets(file); sar.lsarpath=tline(36:size(tline,2)-2);
tline=fgets(file); sar.lsarmax=tline_to_param(tline,36,size(tline,2)-2);
tline=fgets(file); sar.gsarpath=tline(35:size(tline,2)-2);
tline=fgets(file); sar.gsarmax=tline_to_param(tline,37,size(tline,2)-2);
tline=fgets(file); sar.ppmax=tline_to_param(tline,24,size(tline,2)-2);
tline=fgets(file); sar.ppavmax=tline_to_param(tline,32,size(tline,2)-2);

% results
tline=fgets(file); tline=fgets(file);
tline=fgets(file); optimization.resdir=tline(18:size(tline,2)-2);

fclose(file);



















