

function [hess_an hess_numer]=test_hessian(fhandle,hesshandle,x)
% function [hess_an hess_numer]=test_hessian(fhandle,hesshandle,x)

n=size(x,1);

hess_an=hesshandle(x);

% hess_numer=hess_num(fhandle,x);

f=fhandle(x);
% eps=1e-4;  % SC
eps=1e-6;  % SC_RF
hess_numer=zeros(n,n);

for i=1:n
    disp( sprintf('Computing Hessian row #%d out of %d ...',i,n) );
    for j=1:n
        if i==j
            xip=x; xip(i)=xip(i)+eps; fip=fhandle(xip);
            xim=x; xim(i)=xim(i)-eps; fim=fhandle(xim);
            hess_numer(i,j)=(fip+fim-2.0*f)/eps^2;
        else
            xipjp=x; xipjp(i)=xipjp(i)+eps; xipjp(j)=xipjp(j)+eps; fipjp=fhandle(xipjp);
            xipjm=x; xipjm(i)=xipjm(i)+eps; xipjm(j)=xipjm(j)-eps; fipjm=fhandle(xipjm);
            ximjp=x; ximjp(i)=ximjp(i)-eps; ximjp(j)=ximjp(j)+eps; fimjp=fhandle(ximjp);
            ximjm=x; ximjm(i)=ximjm(i)-eps; ximjm(j)=ximjm(j)-eps; fimjm=fhandle(ximjm);
            hess_numer(i,j)=(fipjp+fimjm-fipjm-fimjp)/(4.0*eps^2);
        end
    end
end

% load hess_numer;

figure; imagesc(hess_an); colormap(hot); colorbar; axis image; title('Hessian analytical'); % caxis([-0.002 0.002])
figure; imagesc(hess_numer); colormap(hot); colorbar; axis image; title('Hessian numerical'); % caxis([-0.002 0.002])
figure; imagesc(hess_an-hess_numer); colormap(hot); colorbar; axis image; title('Hessian analytical - Hessian numerical'); % caxis([-0.002 0.002])

