

function write_and_display_bloch_simulation(MT_Bloch,opt,adj,freq)
% function write_and_display_bloch_simulation(MT_Bloch,opt,adj,freq)

nfreq=size(MT_Bloch,1);
if size(freq,2)~=nfreq
    error('Incorrect number of frequencies.');
end

for i=1:nfreq   
    MT=mean(MT_Bloch{i,1},3);
    magimg=abs(MT);
    phaimg=angle(MT)/pi*180;
    
    if strcmpi(opt.display,'on')
        if i==1
            figure;
        end
        magimg(magimg>1)=1;
        subplot(2,nfreq,i); imagesc(asin(magimg)/pi*180);colormap jet; caxis([0 opt.tfa*1.5]); colorbar; axis image; axis off; title(sprintf('Bloch [deg], f=%3.1f Hz',freq(i)))
        subplot(2,nfreq,i+nfreq); imagesc(phaimg);colormap jet; caxis([-180 180]); axis image; axis off; colorbar; title(sprintf('Bloch [rad.], f=%3.1f Hz',freq(i)))
    end
end


