


function write_and_display_bloch_simulation_z(zs,mxz,myz,mzz,opt)
% function write_and_display_bloch_simulation_z(zs,mxz,myz,mzz,opt)

% write on file
arr_dump=zeros( size(zs,1),opt.nslices+1 );
arr_dump(:,1)=zs;
% for sl=1:opt.nslices
    mt=(mxz(:,1).^2+myz(:,1).^2).^0.5;
    arr_dump(:,1+1)=mt/(max(mt)+0.0000001);
% end
% dlmwrite([opt.resdir '/slice_profiles.txt'],arr_dump,'\t');

% display
if strcmpi(opt.display,'on')
    f=figure; title('Slice-selection profiles, Bloch sim. [a. u.]'); hold on; 
    colors='brgyp';
    for sl=1:opt.nslices
        if sl==1
            sbuf=sprintf('legend(''slice #%d''',sl);
        else
            sbuf=[sbuf sprintf(',''slice #%d''',sl)];
        end
        plot(zs*100,arr_dump(:,sl+1),'Color',colors(sl),'LineWidth',2);
        if sl==opt.nslices
            sbuf=[sbuf ');'];
            eval(sbuf); legend('boxoff'); xlabel('z [cm]'); axis([min(zs)*100 max(zs)*100 0 1.2]);
        end
    end
end

