

function mt_img_allfreq=write_and_display_magnetization(x,opt,adj,system,spokes,freq,freq_weight)
% function mt_img_allfreq=write_and_display_magnetization(x,opt,adj,system,spokes,freq,freq_weight)

nfreq=size(freq,2);

mt_allfreq=opt.A_allfreq*x;
mt_img_allfreq=cell(nfreq,1);
for i=1:nfreq
    ind_range=(i-1)*adj.nnonzeropixels + 1 : i*adj.nnonzeropixels;
    mt_img_allfreq{i,1}=zeros(adj.nx,adj.ny);
    mt_img_allfreq{i,1}(adj.ind)=mt_allfreq(ind_range) / sqrt( freq_weight(i) );
    
    magimg=abs( mt_img_allfreq{i,1} );
    phaimg=angle( mt_img_allfreq{i,1} )/pi*180;
    
    if strcmpi(opt.display,'on')
        if i==1
            figure;
        end
        magimg(magimg>1)=1;
        subplot(2,nfreq,i); imagesc(asin(magimg)/pi*180);colormap jet; caxis([0 opt.tfa*1.5]); colorbar; axis image; axis off; title(sprintf('STA [deg], f=%3.1f Hz',freq(i)))
        subplot(2,nfreq,i+nfreq); imagesc(phaimg);colormap jet; caxis([-180 180]); axis image; axis off; colorbar; title(sprintf('STA [rad.], f=%3.1f Hz',freq(i)))
    end
end




